<?php

namespace DsbNext\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class DashboardGUController{
    
    protected $crudService;
    
    public function __construct($connection, $environment, $util, $crudService) {
        $this->crudService	= $crudService;
        $this->connection      = $connection;
        $this->environment     = $environment;
        $this->util            = $util;
    }
    
    public function daysOfStockGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'CDOPERADOR', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        array_push($conditions, array(
            "columnName" => "NIVEL",
            "operator"   => '=',
            "value"      => 'T'
        ));
       
        $data = $this->crudService->getFilteredDataSet('daysOfStockGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("daysOfStockGU", $data));
    }
    
    public function extraRequestGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);

        $data = $this->crudService->getFilteredDataSet('extraRequestGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("extraRequestGU", $data));
    }
    
    public function consumptionDiversionGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);

        $data = $this->crudService->getFilteredDataSet('consumptionDiversionGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("consumptionDiversionGU", $data));
    }
    
    public function processingDateGU(Request\Filter $request, Response $response) {
        $processingDate = $this->util->getDateProc();
        $data = [array('PROCESSINGDATE' => $processingDate)];
		$response->addDataSet(new DataSet("processingDateGU", $data));
    }
    
    public function nextMenuReleaseGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA'];
        $conditions = $this->util->prepareConditions($params);

        $data = $this->crudService->getFilteredDataSet('nextMenuReleaseGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("nextMenuReleaseGU", $data));
    }
    
    public function adjustmentValueGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);

        $data = $this->crudService->getFilteredDataSet('adjustmentValueGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("adjustmentValueGU", $data));
    }
    
    public function daysMenuApprovalGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);

        $data = $this->crudService->getFilteredDataSet('daysMenuApprovalGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("daysMenuApprovalGU", $data));
    }
    
    public function financialImpactGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);

        $data = $this->crudService->getFilteredDataSet('financialImpactGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("financialImpactGU", $data));
    }
    
    public function pendingReleasesGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);

        $data = $this->crudService->getFilteredDataSet('pendingReleasesGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("pendingReleasesGU", $data));
    }
    
    public function daysOfDelayGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);

        $data = $this->crudService->getFilteredDataSet('daysOfDelayGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("daysOfDelayGU", $data));
    }
    
     public function productWithoutMovGU(Request\Filter $request, Response $response) {
        $params = ['CDFILIAL', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        
        $data = $this->crudService->getFilteredDataSet('productWithoutMovGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("productWithoutMovGU", $data));
    }
    
    public function consumptionBudgetGU(Request\Filter $request, Response $response) {
        $filter = $request->getFilterCriteria()->getConditions();
        $params = ['CDFILIAL', 'DTPROCESSA', 'NRORG'];
        $conditions = $this->util->prepareConditions($params);
        array_push($conditions, $filter[0]);

        $data = $this->crudService->getFilteredDataSet('consumptionBudgetGU', $conditions)->getRows();
		$response->addDataSet(new DataSet("consumptionBudgetGU", $data));
    }

}