import { Http } from '@zeedhi/core';

export class GraphicsController {
  public fillGraphicPie({ component }) {
    const props = component.options.props;
    const routeName = props.routeName;
    const seriesNameColumn = props.seriesNameColumn;
    const labelsNameColumn = props.labelsNameColumn;
    const sendObject = {
      filter: [],
    };
    
    if (props.idOrigem) {
      sendObject.filter.push(
        {
          name: 'IDORIGEM',
          operator: '=',
          value: props.idOrigem,
        },
      );
    }
    
    Http.post(`/${routeName}`, sendObject).then((response) => {
      /* eslint no-console: ["error", { allow: ["warn", "error", "info", "log"] }] */
      const data = response.data.dataset[routeName];
      const labels = [];
      const series = [];
      data.forEach((row) => { labels.push(row[labelsNameColumn]); series.push(row[seriesNameColumn]); });
      component.options.labels = labels;
      component.series = series;
      component.updateChart(component.options.labels);
      component.updateChart(component.series);
    });
  }
}
